IMPLICIT NONE

integer*1,dimension(43200*3,3) :: lread
integer*1,dimension(43200,20) :: lwrite
integer*1,dimension(43200) :: lsum, lsum2
real :: zval, zcount
integer*4 :: jl, jl2, jv, jc, jp1, jp2
integer :: imax, imin
character(len=2), dimension(20) :: YVEG

DATA YVEG/"04","05","06","07","08","09","10","11","12","13",&
          "14","15","16","17","18","19","20","21","22","23"/
  
   ! ouverture fichier ecoclimap
open(11,file='/cnrm/surface/faroux/ecosg_final_map6',form='unformatted',access='direct',recl=43200*3)


do jv = 4,23
  open(11+jv,file="frac_ecosg_1km_"//YVEG(jv-3)//".bin",form="unformatted",access="direct",&
         recl=43200)
enddo

!open(111,file="sum_frac_ecosg_1km",form="unformatted",access="direct",recl=43200)

! calcul des sommes de fractions
do jl = 1,21600

print*,'jl ',jl
  do jl2 = 1,3
    read(11,rec=(jl-1)*3+jl2) lread(:,jl2)
  enddo

  lsum(:) = 0

  lwrite(:,:) = 0
  do jv = 4,23
    do jc = 1,43200
      zval = 0.
      do jp1 = (jc-1)*3+1,jc*3
        do jp2 = 1,3
          if (lread(jp1,jp2)==jv) then
            zval = zval + 1.
          elseif (lread(jp1,jp2)>23) then
            if (jv==8) then
              if (lread(jp1,jp2)<=26) then
                zval = zval + 0.1
              elseif (lread(jp1,jp2)<=28) then
                zval = zval + 0.4*0.3
              elseif (lread(jp1,jp2)==29) then
                zval = zval + 0.4*0.4
              elseif (lread(jp1,jp2)==32) then
                zval = zval + 0.3*0.7
              endif
            elseif (jv==23) then
              if (lread(jp1,jp2)>=27.and.lread(jp1,jp2)<=28) then
                zval = zval + 0.4*0.3
              elseif (lread(jp1,jp2)==29.or.lread(jp1,jp2)==33) then
                zval = zval + 0.4*0.4
              elseif (lread(jp1,jp2)>=30.and.lread(jp1,jp2)<=31) then
                zval = zval + 0.5*0.1
              elseif (lread(jp1,jp2)==32) then
                zval = zval + 0.5*0.7
              endif                    
            endif
          endif
        enddo
      enddo

      zval = zval * 100./9.
      lwrite(jc,jv-3) = nint(zval)
    enddo
    lsum(:) = lsum(:) + lwrite(:,jv-3)
  enddo
!  print*,lwrite(1,:)
!  print*,lsum(1)

    lsum2(:) = 0
  do jv = 4,23

    where(lsum(:)/=0) 
      lwrite(:,jv-3) = nint(float(lwrite(:,jv-3))*100./float(lsum(:)))
    endwhere

    lsum2(:) = lsum2(:) + lwrite(:,jv-3)

  enddo
!  print*,lwrite(1,:)
!  print*,lsum2(1)

  do jc = 1,43200
    if (lsum2(jc)>0) then
      if (lsum2(jc)<100) then
        imax = maxloc(lwrite(jc,:),1)
        lwrite(jc,imax) = lwrite(jc,imax) + 100 - lsum2(jc)
        if (lwrite(jc,imax)>100) then 
           print*,'pb avec lwrite + !'
           stop
        endif
      elseif (lsum2(jc)>100) then
        imax = maxloc(lwrite(jc,:),1)
        lwrite(jc,imax) = lwrite(jc,imax) - (lsum2(jc) - 100)
        if (lwrite(jc,imax)<0) then 
           print*,'pb avec lwrite - !'
           stop
        endif
      endif
    endif
  enddo

  lsum2(:) = sum(lwrite(:,:),2)

!  print*,lwrite(1,:)
!  print*,lsum2(1)
  
  do jc = 1,43200
    if (lsum2(jc)/=100.and.lsum2(jc)/=0) then
      print*,'pb avec lsum !',jc,lsum2(jc)
      stop
    endif
  enddo

  do jv = 4,23
    write(11+jv,rec=jl) lwrite(:,jv-3)
  enddo

  !write(111,rec=jl) lsum2(:)

enddo


close(11)
do jv=4,23
  close(11+jv)
enddo
!close(111)


      END
