IMPLICIT NONE

INCLUDE 'mpif.h'

INTEGER, PARAMETER :: NTYPES = 17, NLIN = 16800, NCOL=43200
INTEGER*1,DIMENSION(NCOL,NTYPES) :: ILAI
INTEGER*1, DIMENSION(NCOL*3) :: IECO
INTEGER*1, DIMENSION(NCOL*3) :: ILAI2
CHARACTER(LEN=4), DIMENSION(36) :: YDEC
CHARACTER(LEN=2), DIMENSION(NTYPES) :: YNUM
INTEGER*4 :: JL1, JL2, JC
INTEGER :: JDEC, JT

DATA YNUM/"07","08","09","10","11","12",&
          "13","14","15","16","17","18","19","20","21","22","23"/

DATA YDEC/"0105","0115","0125","0205","0215","0225","0305","0315","0325",&
          "0405","0415","0425","0505","0515","0525","0605","0615","0625",&
          "0705","0715","0725","0805","0815","0825","0905","0915","0925",&
          "1005","1015","1025","1105","1115","1125","1205","1215","1225"/

open(11,file='/cnrm/surface/faroux/ecosg_final_map6',form='unformatted',access='direct',recl=NCOL*3)


DO JDEC = 1,SIZE(YDEC)

  print*,'JDEC ',JDEC
  OPEN(111,file='ALB_NI_VEG_A_300M_'//YDEC(JDEC)//'.dir',form='unformatted',access='direct',recl=NCOL*3)

  DO JT = 1,NTYPES
    OPEN(11+JT,file='ALB_NI_A_VEG_T'//YNUM(JT)//'_D'//YDEC(JDEC)//'.dir',form='unformatted',access='direct',recl=NCOL)
  ENDDO

  DO JL1 = 1,NLIN

    print*,'JL1 ',JL1
    DO JT = 1,NTYPES
      READ(11+JT,REC=JL1) ILAI(:,JT)
    ENDDO

    !print*,'suite1'
    DO JL2 = 1,3
      !print*,'JL2 ',JL2
      READ(11,REC=3600+(JL1-1)*3+JL2) IECO(:)
      !print*,'colonnes'
      DO JC = 1,SIZE(IECO)
        !print*,'JC ',JC
        IF (IECO(JC)>=7.AND.IECO(JC)<=23) THEN
          !print*,FLOOR((JC-1)/3.)+1,IECO(JC)-6
          ILAI2(JC) = ILAI(FLOOR((JC-1)/3.)+1,IECO(JC)-6)
        ELSE
          ILAI2(JC) = -1
        ENDIF
      ENDDO
      WRITE(111,REC=(JL1-1)*3+JL2) ILAI2(:)
    ENDDO
    !print*,'suite2'
    
  ENDDO 
    
  CLOSE(111)
  
  DO JT = 1,NTYPES
    CLOSE(11+JT)
  ENDDO

ENDDO

CLOSE(11)

END
