set -x 
for file in LAI*_2.bin
do
  file2=$(basename $file .bin)
  r.in.bin --overwrite input=/cnrm/surface/faroux/NO_SAVE/NEW_LAI/$file output=${file2}_rs bytes=1 north=80 south=-59.997023809492 east=179.997023811161 west=-180 rows=47040 cols=120960 anull=255 --overwrite
  g.region -p n=80 s=-60 e=180 w=-180 res=0.00277777777777777777
  r.resamp.interp input=${file2}_rs@SWBD output=${file2}_3 method=nearest --overwrite
  r.out.bin -i input=${file2}_3@SWBD output=${file2}_3 null=255 bytes=1 
  g.remove type=raster name=${file2}_rs -f
  g.remove type=raster name=${file2}_3 -f
done
